package com.ruoyi.web.runner;

import cn.hutool.core.bean.BeanUtil;
import com.alibaba.druid.pool.DruidDataSource;
import com.ruoyi.framework.datasource.DynamicDataSource;
import com.ruoyi.quartz.glue.GlueFactory;
import com.ruoyi.quartz.handler.impl.MyJobHandler;
import com.ruoyi.ucp.entity.Formula;
import com.ruoyi.ucp.entity.Method;
import com.ruoyi.ucp.entity.UcpDataSource;
import com.ruoyi.ucp.feign.AdapterApi;
import com.ruoyi.quartz.handler.IJobHandler;
import com.ruoyi.ucp.service.*;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;

@Component
public class LoadDataSourceRunner implements CommandLineRunner {
    @Resource
    private DynamicDataSource dynamicDataSource;
    @Resource
    private IUcpDataSourceService ucpDataSourceService;

    //@Resource
    //private ScriptEngine engine;
    @Resource
    private AdapterApi adapter;
    @Resource
    private IPointInfoService pointService;
    @Resource
    private IStationInfoDayService stationInfoDayService;
    @Resource
    private IStationInfoHourService stationInfoHourService;
    @Resource
    private IMethodService methodService;
    @Resource
    private ILineInfoDayService lineInfoDayService;
    @Resource
    private IFormulaService formulaService;

    @Override
    public void run(String... args) {
        List<UcpDataSource> list = ucpDataSourceService.list();
        List<DruidDataSource> dataSources = BeanUtil.copyToList(list, DruidDataSource.class);
        dynamicDataSource.createDataSource(dataSources);

        //engine.put("adapter", adapter);
        //engine.put("pointService", pointService);
        //engine.put("stationInfoDayService", stationInfoDayService);
        //engine.put("stationInfoHourService", stationInfoHourService);
        //engine.put("lineInfoDayService", lineInfoDayService);

        List<Method> methods = methodService.list();
        List<Formula> formulas = formulaService.list();
        String functionCode = GlueFactory.getFunctionTemplate();
        try {
            for (Method method : methods) {
                //engine.eval(method.getMethodExpression());
                functionCode = functionCode
                        .replace("//此处加公式", method.getMethodExpression() + "\n//此处加公式");
            }
            for (Formula formula : formulas) {
                functionCode = functionCode.replace("//此处加公式", formula.getFormulaExpression() + "\n//此处加公式");
            }
            IJobHandler jobHandler = GlueFactory.getInstance().loadNewInstance(functionCode);
            MyJobHandler.jobHandler = jobHandler;
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
